%define anolis_release 1

%bcond_without libssh2

Name:           libgit2
Version:        1.5.1
Release:        %{anolis_release}%{?dist}
Summary:        C implementation of the Git core methods as a library with a solid API
License:        GPLv2 with exceptions
URL:            https://libgit2.org/
Source0:        https://github.com/libgit2/libgit2/archive/refs/tags/v%{version}.tar.gz

BuildRequires:  gcc
BuildRequires:  cmake >= 3.5.1
BuildRequires:  ninja-build
BuildRequires:  http-parser-devel
BuildRequires:  libcurl-devel
%if %{with libssh2}
BuildRequires:  libssh2-devel
%endif
BuildRequires:  openssl-devel
BuildRequires:  pcre2-devel
BuildRequires:  python3
BuildRequires:  zlib-devel
Provides:       bundled(libxdiff)

%description
libgit2 is a portable, pure C implementation of the Git core methods
provided as a re-entrant linkable library with a solid API, allowing
you to write native speed custom Git applications in any language
with bindings.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains libraries and header files for
developing applications that use %{name}.

%package doc
Summary:   Documents for %{name}
Requires:  %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Doc pages for %{name}.

%prep
%autosetup -p1

# Remove VCS files from examples
find examples -name ".gitignore" -delete -print

# Don't run "online" tests
sed -i '/-sonline/s/^/#/' tests/libgit2/CMakeLists.txt
sed -i '/-score::ftruncate/s/^/#/' tests/libgit2/CMakeLists.txt

# Remove bundled libraries
rm -vr deps

%build
%cmake \
  -GNinja \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DREGEX_BACKEND=pcre2 \
  -DUSE_HTTP_PARSER=system \
  -DUSE_SHA1=HTTPS \
  -DUSE_HTTPS=OpenSSL \
  -DUSE_NTLMCLIENT=OFF \
%if %{without libssh2}
  -DUSE_SSH=OFF \
%endif
  %{nil}
%cmake_build

%install
%cmake_install

%generate_compatibility_deps

%check
%ctest

%files
%license COPYING
%{_bindir}/git2_cli
%{abidir}/git2_cli-option.list
%{_libdir}/libgit2.so.1.5*
%{abidir}/libgit2*.dump

%files doc
%doc AUTHORS docs README.md

%files devel
%doc examples
%{_libdir}/libgit2.so
%{_libdir}/pkgconfig/libgit2.pc
%{_includedir}/git2.h
%{_includedir}/git2/

%changelog
* Sun Jan 22 2023 Funda Wang <fundawang@yeah.net> - 1.5.1-1
- New version 1.5.1

* Mon Dec 19 2022 Funda Wang <fundawang@yeah.net> - 1.5.0-1
- New version 1.5.0

* Tue Jul 12 2022 happy_orange <songnannan@linux.alibaba.com> - 1.3.1-1
- Init pcakage from upstream
